﻿-- ----------------------------------------------------------------------------
-- GridAutoFrameSize by smuggles
-- ----------------------------------------------------------------------------
local L = AceLibrary("AceLocale-2.2"):new("GridAutoFrameSize")
local AceOO = AceLibrary("AceOO-2.0")
local RL = AceLibrary("Roster-2.1")

GridAutoFrameSize = GridStatus:NewModule("GridAutoFrameSize")
GridAutoFrameSize.defaultDB = {
	autoSizeFrames = 1,
	}

function GridAutoFrameSize:OnEnable()
	local opt = GridLayout.options.args
	opt["autoSizeFrames"] = {
		type = "toggle",
		name = L["Auto Size Raid Frame"],
		desc = L["Automatically adjusts frame layout to raid size"],
		order = 29,
		get = function ()
			return GridLayout.db.profile.autoSizeFrames
		end,
		set = function (v)
			GridLayout.db.profile.autoSizeFrames = v
		end,	
	}
	
	if AceLibrary:HasInstance("Roster-2.1") then
		self:RegisterEvent("RosterLib_RosterUpdated", "CheckRoster")
	else
		self:RegisterBucketEvent({"RAID_ROSTER_UPDATE", "PARTY_MEMBERS_CHANGED"}, 1, "CheckRoster")
	end	
end

function GridAutoFrameSize:CheckRoster()
	if (not  GridLayout.db.profile.autoSizeFrames) then
		return;
	end
	
	local raid = GetNumRaidMembers()
	local party = GetNumPartyMembers()
	--DEFAULT_CHAT_FRAME:AddMessage("roster checking");
	if not grouped and raid > 0 then
		grouped = 1 -- raid
		--DEFAULT_CHAT_FRAME:AddMessage("raid")
	elseif not grouped and party > 0 then
		grouped = 0 -- group
		--DEFAULT_CHAT_FRAME:AddMessage("group")
	elseif grouped then
		if grouped == BWPARTY and raid > 0 then
			grouped = 1
			--DEFAULT_CHAT_FRAME:AddMessage("raid")
		elseif raid == 0 and party == 0 then
			grouped = nil
			--DEFAULT_CHAT_FRAME:AddMessage("not grouped")
		end
	end
	if (grouped == 1) then
		local maxgroup = 1;
		for raidIndex = 1, raid, 1 do
			local name, rank, subgroup = GetRaidRosterInfo(raidIndex);				
			if (subgroup > maxgroup) then
				maxgroup = subgroup;
			end
			--DEFAULT_CHAT_FRAME:AddMessage(""..name.." - "..subgroup)
		end
		--DEFAULT_CHAT_FRAME:AddMessage("- "..maxgroup)
		local glayout = nil		
		if maxgroup > 5 then
			glayout = "By Group 40";
		elseif (maxgroup == 5) then
			glayout = "By Group 25";
		elseif (maxgroup == 4) then
			glayout = "By Group 20";
		elseif (maxgroup == 3) then
			glayout = "By Group 15";
		elseif (maxgroup <= 2) then
			glayout = "By Group 10";
		end			
		if (glayout) then
			GridLayout:LoadLayout(glayout);
		end		
	else
		GridLayout:LoadLayout("By Group 10");
	end
end
